// Imagine++ project
// Project:  matrices2
// Author:   keriven
// Date:     2007/10/19

#include <iostream>
#include <string>
using namespace std;

//==================================================
// functions on matrices
// could be in matrix.h and matrix.cpp

struct Matrix {
    int m,n;
    double* t;
};

Matrix create(int m,int n) {
    Matrix M;
    M.m=m;
    M.n=n;
    M.t=new double[m*n];
    return M;
}

void destroy(Matrix M) {
    delete[] M.t;
}

Matrix product(Matrix A,Matrix B) {
    if(A.n!=B.m) {
        cout << "Error!" << endl;
        exit(1);
    }
    Matrix C=create(A.m,B.n);
    for(int i=0; i<A.m; i++)
        for(int j=0;j<B.n;j++) {
            // Cij=Ai0*B0j+Ai1*B1j+...
            C.t[i+C.m*j]=0;
            for(int k=0; k<A.n; k++)
                C.t[i+C.m*j]+=A.t[i+A.m*k]*B.t[k+B.m*j];
        }
    return C;
}

void display(string s,Matrix M) {
    cout << s << " =" << endl;
    for(int i=0; i<M.m; i++) {
        for(int j=0; j<M.n; j++)
            cout << M.t[i+M.m*j] << " ";
        cout << endl;
    }
}

//==================================================
// Usage

int main()
{
    Matrix A=create(2,3);
    for(int i=0; i<2; i++)
        for(int j=0; j<3; j++)
            A.t[i+2*j]=i+j;
    display("A",A);
    Matrix B=create(3,5);
    for(int i=0; i<3; i++)
        for(int j=0; j<5; j++)
            B.t[i+3*j]=i+j;
    display("B",B);
    Matrix C=product(A,B);
    display("C",C);
    destroy(C);
    destroy(B);
    destroy(A);
    return 0;
}
